<script lang="ts">
  import PageHeader from '$lib/components/layout/PageHeader.svelte';
  import cards from '$lib/components/pages/about/about-cards';
  import CompetitionTimelineRow from './CompetitionTimelineRow.svelte';
  import AboutCard from '$lib/components/pages/about/AboutCard.svelte';
  import topology from '$lib/assets/images/about/topology.png';
  import { discordChannels } from '$lib/constants/urls';
  import CompetitionTimeline from '$routes/(app)/about/CompetitionTimeline.svelte';

  const infrastructure_points = 10000;
  const ctf_points = 2000;
  const point_base = infrastructure_points / 20;

  const scoring_rubric = [
    {
      vm: 'www',
      service: 'WWW Content',
      points: point_base * 3,
      notes: 'Web content is correct. This is checked through the router.'
    },
    {
      vm: 'www',
      service: 'SSL & Content',
      points: point_base * 4,
      notes:
        'Page is served with a valid SSL certificate for the domain "www.team<T>.ncaecybergames.org" and web content is correct. Checked through the router. Requires external DNS.'
    },
    {
      vm: 'dns',
      service: 'Internal DNS',
      points: point_base * 1,
      notes: "teamX.net hostnames resolve correctly. These will be scored from inside the participant's network."
    },
    {
      vm: 'dns',
      service: 'External DNS',
      points: point_base * 1,
      notes: 'teamX.ncaecybergames.org hosts resolve correctly. These will be scored through the router.'
    },
    {
      vm: 'shell',
      service: 'ssh login',
      points: point_base * 1,
      notes: 'Scoring Users are able to log in via SSH key'
    },
    {
      vm: 'shell',
      service: 'ftp content',
      points: point_base * 3,
      notes: 'Files from the list exists, can be downloaded, and contents pass an integrity check.'
    },
    {
      vm: 'shell',
      service: 'ftp write',
      points: point_base * 1,
      notes: 'Scoring users are able to write a file to the remote FTP server.'
    },
    {
      vm: 'db',
      service: 'mySQL read/write',
      points: point_base * 2,
      notes: 'MySQL scoring user is able to connect, authenticate, read and write data'
    },
    {
      vm: 'shell',
      service: 'ftp login',
      points: point_base * 1,
      notes: 'Scoring users are able to log in via ftp'
    },
    {
      vm: 'router',
      service: 'ICMP ping',
      points: point_base * 1,
      notes: "Returns an ICMP Ping on the router's external interface"
    },
    {
      vm: 'dns',
      service: 'SSH',
      points: point_base * 1,
      notes: 'SSH access with scoring users. Checked from the internal network.'
    },
    {
      vm: 'db',
      service: 'SSH',
      points: point_base * 1,
      notes: 'SSH access with scoring users. Checked from the internal network.'
    }
  ];
</script>

<PageHeader title="About" />

<section class="grid grid-rows-1 grid-cols-1 lg:grid-cols-2 xl:grid-cols-3 mt-20 mx-10 lg:ml-0">
  <div class="hidden lg:block relative h-96">
    <div
      class="relative lg:absolute bottom-1/3 w-full h-full bg-[url('$lib/assets/images/about/about_page_computer.png')] bg-contain bg-no-repeat" />
  </div>
  <div class="xl:col-span-2" style="max-width: 1100px">
    <h1 class="text-4xl lg:text-6xl font-bold text-secondary uppercase text-center lg:text-left">
      What's this all about?
    </h1>
    <p class="text-xl leading-loose text-cyber-blue-900">
      NCAE Cyber Games is a cyber security competition for college students who have never participated in a competition
      or hackathon before. Cyber competitions are a great way to build your skills and learn about the industry, but
      they can be intimidating if you’ve never tried one before. This program aims to make it easy (and fun) for
      students to see how competitions work and learn with others who are also new.
    </p>
  </div>
</section>

<section class="mx-10 mt-10 xl:mt-0">
  <h1 class="text-4xl lg:text-6xl font-bold text-secondary uppercase text-center">
    Why should I compete?
  </h1>
  <p class="text-center text-2xl md:text-3xl text-cyber-blue-900">
    <em>
      If you’re thinking about pursuing a career in cybersecurity, participating in cyber competitions provide several
      big benefits:
    </em>
  </p>
</section>

<section
  class="my-20 lg:mt-40 mx-10 flex flex-col sm:grid grid-cols-2 grid-rows-2 lg:grid-rows-1 lg:grid-cols-4 gap-5 xl:gap-10">
  {#each cards as card}
    <AboutCard {...card} />
  {/each}
</section>

<section class="my-20 mx-10 mt-10 xl:mt-0">
  <h1 class="text-4xl lg:text-6xl font-bold text-secondary uppercase text-center">
    What should a competitor expect on competition day?
  </h1>
  <p class="text-xl leading-loose text-cyber-blue-900">
    NCAE Cyber Games is a combination of capture the flag (CTF) and red versus blue infrastructure competition. As a
    competitor, you will work with your teammates to defend your systems from the NCAE Cyber Games red team. While the
    red team will be your opposition on competition day, you will be vying for the top score against other teams. To
    beat the competition, your team will need to act as a unified force to keep the red team out of your systems and
    score points in the CTF.
  </p>

  <h2 class="mt-10 text-3xl lg:text-6xl font-bold text-secondary uppercase text-center">Competition schedule</h2>

  <p class="text-xl leading-loose text-cyber-blue-900">
    Be sure to allocate the entire day in your schedule for the competition. The competition lasts for 7.5 hours, which
    includes a 1-hour lunch break/Q&A in the middle of the day, and a 15-30 minute closing ceremony at the end of the
    day to discuss scores and feedback, and prizes!
  </p>

  <CompetitionTimeline>
    <CompetitionTimelineRow>
      <span slot="time">T-00:30</span>
      <div slot="events">Competition Platform is unlocked</div>
      <p slot="description">
        Test your team's access, and prepare for the games to begin! Reach out to staff members with any issues.
      </p>
    </CompetitionTimelineRow>
    <CompetitionTimelineRow>
      <span slot="time">T+00:00</span>
      <div slot="events">
        <p>Competition Begins</p>
        <p style="color:green;">Scoring Begins</p>
        <p style="color:green;">VMs / CTF Opened</p>
      </div>
      Check Discord and your welcome video for instructions on how to get started
      <p slot="description" />
    </CompetitionTimelineRow>
    <CompetitionTimelineRow>
      <span slot="time"> T+03:00 </span>
      <div slot="events">
        <p>Lunch Break</p>
        <p style="color:red;">Scoring Stops</p>
        <p style="color:red;">VMs / CTF Closed</p>
      </div>
      <p slot="description">Eat the healthy lunch you packed and take a break!</p>
    </CompetitionTimelineRow>
    <CompetitionTimelineRow>
      <span slot="time"> T+03:30 </span>
      <div slot="events">
        Lunchtime Q&A at the <b>
          <a class="whitespace-nowrap" href={discordChannels.mainStage}>#main-stage</a>
        </b> channel in Discord
      </div>
      <p slot="description">Ask questions and talk about how things are going so far</p>
    </CompetitionTimelineRow>

    <CompetitionTimelineRow>
      <span slot="time"> T+04:00 </span>
      <div slot="events">
        <p>Competition Resumes</p>
        <p style="color:green;">Scoring Resumes</p>
        <p style="color:green;">VMs / CTF Opened</p>
      </div>
    </CompetitionTimelineRow>
    <CompetitionTimelineRow>
      <span slot="time"> T+07:00 </span>
      <div slot="events">
        <p>Competition Ends</p>
        <p style="color:red;">Scoring Ends</p>
        <p style="color:red;">VMs / CTF Closed</p>
        <p>Final Scores Calculated</p>
      </div>
      <p slot="description">
        Take a breather! Great job! Make sure you take the survey if you haven't already. Make your team participant
        votes Nominate a member of your team to speak on behalf of your team in the closing ceremony.
      </p>
    </CompetitionTimelineRow>
    <CompetitionTimelineRow>
      <span slot="time"> T+07:15 </span>
      <div slot="events">
        <p>Closing Ceremonies</p>
        <p>Round-table on team experiences</p>
        <p>Winning team announced</p>
      </div>
      <p slot="description">
        Hear some feedback from our team as well as other competitors. Share your experiences and get prizes!
      </p>
    </CompetitionTimelineRow>
  </CompetitionTimeline>

  <h2 class="mt-10 text-3xl lg:text-6xl font-bold text-secondary uppercase text-center">Example Topology</h2>

  <p class="text-xl leading-loose text-cyber-blue-900">
    The topology shown below is an example of a previous environment used in the NCAE Cyber Games. There are no
    assurances that future events will use this exact topology. On competition day, teams will gain access to an
    existing set of infrastructure systems that will be under attack by the NCAE Cyber Games red team. Blue teams are
    tasked with evicting the red team and securing their services against further attack while keeping the services
    active for the users (scoring criteria).
  </p>

  <p class="mt-5 text-xl leading-loose text-cyber-blue-900">
    On competition day you will be assigned a team number 1-24. The <b>t</b> in the diagram will be replaced by your
    team number. For example, <b>Team15</b>'s router will be located at <b>192.168.15.1</b> internally and
    <b>172.18.13.15</b> externally.
  </p>

  <div class="flex flex-col mx-20 my-10">
    <img src={topology} alt="brand" />
  </div>

  <h2 class="mt-10 text-3xl lg:text-6xl font-bold text-secondary uppercase text-center">Competition scoring</h2>

  <p class="text-xl leading-loose text-cyber-blue-900">
    On competition day, you will be provided with a table detailing what services on which resources need to stay online
    and secured against the red team opposition. The table provided below is only an example of what will be provided on
    competition day. Actual point values and services may differ.
  </p>

  <div class="my-5 ml-5">
    <p><b>Point Values:</b></p>
    <li><b>Infrastructure:</b> {infrastructure_points} points</li>
    <li><b>CTF:</b> {ctf_points} points</li>
  </div>

  <div class="mx-1 overflow-x-auto">
    <table cellpadding="5">
      <tbody>
        <tr>
          <th>VM</th>
          <th>Service</th>
          <th>Points</th>
          <th>Notes</th>
        </tr>
        {#each scoring_rubric as row}
          <tr>
            <td>{row.vm}</td>
            <td>{row.service}</td>
            <td>{row.points}</td>
            <td>{row.notes}</td>
          </tr>
        {/each}
      </tbody>
    </table>
  </div>
</section>

<style>
  /* :global here tells svelte this applies to elements it's not aware of (the div's within CompetitionTimelineRow) */
  .competition-timeline > :global(div:nth-child(even)) {
    background-color: #d6eeee;
  }

  table,
  th,
  td {
    border: 1px solid black;
    border-collapse: collapse;
  }
  th {
    text-align: left;
  }
</style>
